

stcellphone={}

stcellphone.gfx = loadgfx("weapons/st-cellphone.png")
setmidhandle(stcellphone.gfx)
stcellphone.sfx = loadsfx("st-ring.wav")
stcellphone.hello = loadsfx("st-hello.wav")
stcellphone.attention = loadgfx("attention.png")

stcellphone.id = addweapon("stcellphone", "Cellphone", stcellphone.gfx, 2, 2)

function stcellphone.findnearestplayer(x,y)
	players = playertable()
	nearest = nil
	distance = nil
	for k,v in pairs(players) do
		dist = math.abs(x - getplayerx(v)) + math.abs(y - getplayery(v))
		if (getplayerhealth(v) > 0) and ((distance == nil) or (dist < distance)) then
			nearest = v
			distance = dist
		end
	end
	return nearest
end

function stcellphone.draw()
	if (weapon_position == 0) then
		hudpositioning(pos_invisible, stcellphone.gfx)
	end
end

function stcellphone.attack(attack)
	if (weapon_position == 1) then
		weapon_position=0
		useweapon()
		id = createprojectile(stcellphone.proj.id)
		projectiles[id] = {}
		projectiles[id].x = weapon_x
		projectiles[id].y = weapon_y
		projectiles[id].sx = 0
		projectiles[id].sy = 0
		projectiles[id].landed = false
		projectiles[id].landedtime = nil
		projectiles[id].ringed = 0
		projectiles[id].rangegangen = false
		projectiles[id].rangegangentime = nil
		endturn()
	end
end

stcellphone.proj={}
stcellphone.proj.id = addprojectile("stcellphone.proj")

function stcellphone.proj.draw(id)
	setcolor(255,255,255)
	setblend(blend_alpha)
	drawimage(stcellphone.gfx, projectiles[id].x, projectiles[id].y)
	if (not(stcellphone.nearestplayer == nil)) and (getplayerhealth(stcellphone.nearestplayer) > 0) and (not(projectiles[id].rangegangen)) then
		setscale(0.1,0.1)
		setmidhandle(stcellphone.attention)
		drawimage(stcellphone.attention, getplayerx(stcellphone.nearestplayer)-1, getplayery(stcellphone.nearestplayer)-25)
		setscale(1,1)
	end
end

function stcellphone.proj.update(id)
	if (projectiles[id].rangegangen) then
		if (getplayerhealth(stcellphone.nearestplayer) <= 0) then
			stopchannel(0)
		end
		if (getframe() - projectiles[id].rangegangentime >= 2*50) then
			arealdamage(projectiles[id].x, projectiles[id].y, 40, 10)
			terrainexplosion(projectiles[id].x, projectiles[id].y, 20, 1)
			stcellphone.nearestplayer = nil
			freeprojectile(id)
		end
	elseif (not(projectiles[id].landed)) then
		projectiles[id].sx = projectiles[id].sx + getwind()*0.1
		projectiles[id].sy = projectiles[id].sy + getgravity()

		projectiles[id].x = projectiles[id].x + projectiles[id].sx
		projectiles[id].y = projectiles[id].y + projectiles[id].sy

		if (collision(stcellphone.gfx, projectiles[id].x, projectiles[id].y, 1, 0) == 1) then
			projectiles[id].landed = true
			projectiles[id].landedtime = getframe()
			projectiles[id].sx = 0
			projectiles[id].sy = 0
			stcellphone.nearestplayer = stcellphone.findnearestplayer(projectiles[id].x, projectiles[id].y)
		end

		if (projectiles[id].y > getwatery()) then
			stcellphone.nearestplayer = nil
			particle(p_waterhit,projectiles[id].x,projectiles[id].y)
			playsound(sfx_hitwater1)
			freeprojectile(id)
		end
	else
		if (channelplaying(0) == 0) then
			projectiles[id].ringed = projectiles[id].ringed + 1
			if (projectiles[id].ringed > 8) then
				stcellphone.nearestplayer = nil
				freeprojectile(id)
			else
				playsound(stcellphone.sfx, 0)
			end
		end
		if (not(stcellphone.nearestplayer == nil)) then
			if (projectiles[id].x > getplayerx(stcellphone.nearestplayer)) then
				if (collision(colplayer, getplayerx(stcellphone.nearestplayer)+1, getplayery(stcellphone.nearestplayer)-3, 1, 0) == 0) then
					playerposition(stcellphone.nearestplayer, getplayerx(stcellphone.nearestplayer)+1, getplayery(stcellphone.nearestplayer)-3)
				end
			elseif (projectiles[id].x < getplayerx(stcellphone.nearestplayer)) then
				if (collision(colplayer, getplayerx(stcellphone.nearestplayer)-1, getplayery(stcellphone.nearestplayer)-3, 1, 0) == 0) then
					playerposition(stcellphone.nearestplayer, getplayerx(stcellphone.nearestplayer)-1, getplayery(stcellphone.nearestplayer)-3)
				end
			end
		end
		if (collision(stcellphone.gfx, projectiles[id].x, projectiles[id].y, 0, 1) == 1) then
			projectiles[id].rangegangen = true
			projectiles[id].rangegangentime = getframe()
			stopchannel(0)
			playsound(stcellphone.hello, 0)
		end
	end
end